   function qhvec =  qhfunct(type1, ZS, thres),
   
   %  output qhvec is an array of length(thres)-1 column and  length(ZS) rows 
   %  entries are either 0 or 1 whether regime is active or not
   %  type1 is equal to  1 = SETAR : 2 = PLTAR : 3 = STAR
   
  n = size(ZS, 1); % this should be  n.obs. - max(p, d) from the calling routine 
   nr  = size(thres, 2)-1;   % number of regimes 
   
   qhvec  =  zeros(n, nr); %size(qhvec), %  initialize  the matruix qhvec

   if type1==1,              % SETAR
   
    ycol = 0;
for  regime = 1:nr, 
    clear r1,  clear r2, r1 = thres(regime);  r2 = thres(regime+1);  %  r2=threshold
% idx  is the array that includes the indexes of the observations in the (cross)regime
    clear idx, idx  =  find(ZS>r1 & ZS<=r2);   %size(idx),
       ycol = ycol + 1;
    qhvec(idx,  ycol) =  1;  % set to 1 the obs. in regime (regime, thres)
end, 

     end,

   if type1==2,              % PLTAR
   
    ycol = 0;
for  regime = 1:nr, 
    clear r1,  clear r2, r1 = thres(regime);  r2 = thres(regime+1);  %  r1=threshold
% idx  is the array that includes the indexes of the observations in the (cross)regime
      if regime==1, ycol=ycol+1; qhvec(:,  ycol) =  ZS; else,  
    clear idx, idx  =  find(ZS>r1);   %size(idx),
       ycol = ycol + 1;
    qhvec(idx,  ycol) =  ZS(idx) - r1;  % set to u-r_{i-1} the obs. in (regime, thres)
     end,
end, 

     end,
    if type1==3,             % STAR
        
        stthre = thres(1);   stgamma= thres(2);  
        qhvec= (1./(1+ exp(-stgamma.*(ZS- stthre))));
        
    end,
        

